package com.danitheskunk.skunkworks;

import org.lwjgl.BufferUtils;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.ByteBuffer;

import static com.danitheskunk.skunkworks.GraphicsBackend.*;

public class Engine {
	public Image loadImage(String path) {
		ByteBuffer buf;
		byte[] bytes;
		try(FileInputStream fis = new FileInputStream(path)) {
			bytes = fis.readAllBytes();
		} catch(FileNotFoundException e) {
			throw new RuntimeException(e);
		} catch(IOException e) {
			throw new RuntimeException(e);
		}
		buf = BufferUtils.createByteBuffer(bytes.length);
		buf.put(bytes);
		buf.flip();
		return new Image(buf);
	}

	public IWindow openWindow(int width, int height, String title) {
		return openWindow(width, height, title, OPENGL);
	}

	public IWindow openWindow(int width, int height, String title, GraphicsBackend graphicsBackend) {
		return switch(graphicsBackend) {
			case OPENGL -> new GLWindow(width, height, title);
		};
	}
}
