package com.danitheskunk.skunkworks;

import org.lwjgl.stb.STBImage;

import java.nio.ByteBuffer;

public class Image {
	byte[] data;
	int width, height;
	Image(ByteBuffer buffer) {
		//todo: resorce system
		int[] x = {0}, y = {0}, n = {0};
		var img = STBImage.stbi_load_from_memory(buffer, x, y, n, 4);
		width = x[0];
		height = y[0];
		data = new byte[width * height * 4];
		img.get(data);
	}

	public byte[] getData() {
		return data;
	}

	public Color getPixel(Vec2i pos) {
		int i = pos.getX() * 4 + pos.getY() * 4 * width;
		return new Color(
			data[i + 0],
			data[i + 1],
			data[i + 2],
			data[i + 3]
		);
	}

	public void setPixel(Vec2i pos, Color col) {
		int i = pos.getX() * 4 + pos.getY() * 4 * width;
		data[i + 0] = col.r;
		data[i + 1] = col.g;
		data[i + 2] = col.b;
		data[i + 3] = col.a;
	}
}
